#Water Damage
execute as @a[team=InGame] at @s if score IsIt GameStarted matches 1 if block ~ ~ ~ water run effect give @s wither 1 1 true

#Elimination Detection
execute as @a[team=InGame,nbt={ActiveEffects:[{Id:20b}]}] run scoreboard players set @s HadWither 1
execute as @a[team=InGame,scores={HadWither=1}] at @s if score IsIt GameStarted matches 1 if score @s Deaths matches 1 if score IsIt GraceOver matches 0 run advancement grant @s only rising_flood:wait_for_the_lifeguard
execute as @a[team=InGame,scores={HadWither=1}] at @s if score IsIt GameStarted matches 1 if score @s Deaths matches 1 run advancement grant @s only rising_flood:i_cant_swim
execute as @a[team=InGame,scores={HadWither=1}] at @s if score IsIt GameStarted matches 1 if score @s Deaths matches 1 run tellraw @a ["",{"selector":"@s","bold":true,"color":"dark_red"},{"text":" has been eliminated","italic":true,"color":"red"}]
execute as @a[team=InGame,scores={HadWither=1}] at @s if score IsIt GameStarted matches 1 if score @s Deaths matches 1 run team join Spectators
scoreboard players reset @a Deaths
scoreboard players reset @a[team=InGame,nbt=!{ActiveEffects:[{Id:20b}]}] HadWither
scoreboard players reset @a[team=Spectators] HadWither

#End Detection
execute if score IsIt GameStarted matches 1 run scoreboard players reset PlayersLeft Winner
execute as @a[team=InGame] at @s if score IsIt GameStarted matches 1 run scoreboard players add PlayersLeft Winner 1
execute if score IsIt GameStarted matches 1 store result score PlayersLeft WinnerCopy run scoreboard players get PlayersLeft Winner
execute if score PlayersLeft WinnerCopy matches 1 if score IsIt GameStarted matches 1 run function rsfdp:finish
execute if score PlayersLeft WinnerCopy matches 0 if score IsIt GameStarted matches 1 run function rsfdp:finish



#WaterRisen + BorderStart
execute as @e[name="water_level"] at @s unless entity @s[type=armor_stand,y=1,dy=216] run scoreboard players set IsIt WaterRisen 1
execute as @e[name="water_level"] at @s if entity @s[type=armor_stand,y=0,dy=217] run scoreboard players set IsIt WaterRisen 0

execute if score IsIt BorderSetupRun matches 0 if score IsIt WaterRisen matches 1 run function rsfdp:border_setup

execute if score IsIt BorderSpawn matches 1 run spawnpoint @a -16 195 128

execute if score IsIt WaterRisen matches 0 run scoreboard players set IsIt BorderSetupRun 0

#Anti-Submarining
execute as @a[team=InGame] at @s store result score @s Water_Level run data get entity @s Pos[1]
execute as @a[team=InGame] at @s if score @s Water_Level < y Water_Level run fill ~ ~ ~ ~ ~1 ~ water

#Kill Long Witch Potions
execute as @e[type=potion] at @s if block ~ ~ ~ water run kill @s

#MidJoin MidGame
execute as @a[team=Lobby] if score IsIt GameStarted matches 1 run team join Spectators
gamemode spectator @a[team=Spectators]

#Advancements
execute as @a[team=InGame,nbt={RootVehicle:{Entity:{id:"minecraft:boat"}}}] at @s if score IsIt GameStarted matches 1 if block ~ ~-1 ~ water run advancement grant @s only rising_flood:a_drunken_sailor
execute as @a[nbt={Inventory:[{id:"minecraft:axolotl_bucket"}]}] run advancement grant @s only rising_flood:fren
execute as @a[nbt={Inventory:[{id:"minecraft:sponge"}]}] run advancement grant @s only rising_flood:mr_squarepants_its_an_honor
execute as @a[nbt={Inventory:[{id:"minecraft:ender_pearl"}]}] run advancement grant @s only rising_flood:a_second_chance
execute as @a[nbt={Inventory:[{id:"minecraft:written_book",tag:{author:_TheSwagUnicorn_}}]}] run advancement grant @s only rising_flood:book_thief
execute as @a[team=InGame] at @s if score IsIt WaterRisen matches 1 if block ~ ~-1 ~ bedrock run advancement grant @s only rising_flood:olympic_diver

#Action Bars
execute if score IsIt GraceOver matches 0 if score IsIt GameStarted matches 1 run title @a[team=!Lobby] actionbar ["",{"text":"Grace Period:","bold":true,"color":"blue"},{"text":" ","color":"blue"},{"score":{"name":"Time","objective":"GraceCounter"},"italic":true,"color":"blue"},{"text":"s","italic":true,"color":"blue"}]
execute if score IsIt GraceOver matches 1 if score IsIt GameStarted matches 1 unless score IsIt BorderSetupRun matches 1 run title @a[team=!Lobby] actionbar ["",{"text":"Water Level:","bold":true,"color":"gold"},{"text":" ","color":"gold"},{"score":{"name":"y","objective":"Water_Level"},"italic":true,"color":"gold"}]
execute if score IsIt BorderSpawn matches 0 if score IsIt GameStarted matches 1 if score IsIt BorderSetupRun matches 1 run title @a[team=!Lobby] actionbar ["",{"text":"Border Counter:","bold":true,"color":"red"},{"text":" ","color":"red"},{"score":{"name":"Time","objective":"BorderCounter"},"italic":true,"color":"red"},{"text": "s","color": "red","italic": true}]
execute as @a[team=!Lobby] at @s if score IsIt BorderSpawn matches 1 if score IsIt GameStarted matches 1 if score IsIt BorderSetupRun matches 1 if entity @s[x=-20,dx=7,z=124,dz=7] run title @s actionbar [{"text": "You ","color": "green"},{"text": "ARE ","bold": true,"color": "dark_green"},{"text": "in the safe zone","bold": false,"color": "green"}]
execute as @a[team=!Lobby] at @s if score IsIt BorderSpawn matches 1 if score IsIt GameStarted matches 1 if score IsIt BorderSetupRun matches 1 unless entity @s[x=-20,dx=7,z=124,dz=7] run title @s actionbar [{"text": "You ","color": "red"},{"text": "ARE NOT ","bold": true,"color": "dark_red"},{"text": "in the safe zone","bold": false,"color": "red"}]


#Spectator Boundaries
execute as @a[team=InGame,gamemode=spectator,tag=generating] at @s unless score IsIt GameStarted matches 1 unless entity @s[x=-80,dx=130,y=57,dy=199,z=63,dz=130] run tp @s -16.0 92 128.0
execute as @a[team=Spectators,gamemode=spectator] at @s unless entity @s[x=-80,dx=130,y=0,dy=300,z=63,dz=130] run tp @s -16.0 ~ 128.0

#Bossbars: 
#Water
execute if score Flood WaterSpeed matches 1 run bossbar set minecraft:water_rising max 115
execute if score Flood WaterSpeed matches 2 run bossbar set minecraft:water_rising max 55
execute if score Flood WaterSpeed matches 3 run bossbar set minecraft:water_rising max 15

execute store result bossbar minecraft:water_rising value run scoreboard players get tick WaterBossbar


execute if score IsIt GraceOver matches 1 if score IsIt GameStarted matches 1 if score IsIt WaterRisen matches 0 run bossbar set minecraft:water_rising players @a
execute if score IsIt GraceOver matches 1 if score IsIt GameStarted matches 1 if score IsIt WaterRisen matches 1 run bossbar set minecraft:water_rising players @a[name=""]
execute if score IsIt GraceOver matches 0 if score IsIt GameStarted matches 0 if score IsIt WaterRisen matches 0 run bossbar set minecraft:water_rising players @a[name=""]

execute if score IsIt GraceOver matches 1 if score IsIt GameStarted matches 1 if score IsIt WaterRisen matches 0 if score Flood WaterSpeed matches 1 if score tick WaterBossbar matches 0 run scoreboard players set tick WaterBossbar 120
execute if score IsIt GraceOver matches 1 if score IsIt GameStarted matches 1 if score IsIt WaterRisen matches 0 if score Flood WaterSpeed matches 2 if score tick WaterBossbar matches 0 run scoreboard players set tick WaterBossbar 60
execute if score IsIt GraceOver matches 1 if score IsIt GameStarted matches 1 if score IsIt WaterRisen matches 0 if score Flood WaterSpeed matches 3 if score tick WaterBossbar matches 0 run scoreboard players set tick WaterBossbar 20
execute if score IsIt GraceOver matches 1 if score IsIt GameStarted matches 1 if score IsIt WaterRisen matches 0 run scoreboard players remove tick WaterBossbar 1
#Border
execute store result bossbar minecraft:border_shrinking value run scoreboard players get tick BorderBossbar

execute if score IsIt GameStarted matches 1 if score IsIt BorderSpawn matches 1 run bossbar set minecraft:border_shrinking players @a
execute if score tick BorderBossbar matches 0 run bossbar set minecraft:border_shrinking players @a[name=""]

execute if score IsIt BorderSpawn matches 1 unless score tick BorderBossbar matches 0 run scoreboard players remove tick BorderBossbar 1


schedule function rsfdp:tick_game 1t